
/* -- Convertor ".dis" to ".z80" file for Avocet compiler (v1.0) -- */

#include <stdio.h>
#include <dir.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <process.h>
#include <fcntl.h>
#include <sys\stat.h>

#define BUFMY (16384+8192)

void main (int argc,char *argv[])
  {
  char text[80],text_2[80],file_out[80],drive[3],dir[66],name[9];
  char buf1[BUFMY],buf2[BUFMY];
  char *token,*token2;
  FILE *fdis,*fz80;
  int  i,n;

  if (argc<2||argc>3)
    {
    printf ("\nBad arguments\n");
    exit(1) ;
    }

  fdis=fopen(argv[1],"rt");
  if (fdis==NULL)
    {
    printf ("\n Can't open file %s ",argv[1]);
    perror("");
    exit(1);
    }
  if (argc==2)
    {
    fnsplit(argv[1],drive,dir,name,NULL);
    fnmerge(file_out,drive,dir,name,".z80");
    }
  else strcpy (file_out,argv[2]);

  fz80=fopen (file_out,"wt");

  if (fz80==NULL)
    {
    printf ("\n Can't creat file %s ",file_out);
    perror("");
    exit(1);
    }

  setvbuf(fdis,buf1,_IOFBF,BUFMY);
  setvbuf(fz80,buf2,_IOFBF,BUFMY);


/* --------- MAIN BLOCK --------- */

  for (i=1;;i++)
    {
    fgets (text,80,fdis);
    if (feof(fdis)) break;

    n=strcspn(text,".;");

    if (text[n]==';') fputs(text+n,fz80);

    if (text[n]=='.')
      {
      strcpy(text_2,text+n+1);
      token=strtok(text_2," \t\n");

      if (token==NULL) break;

      token2=strtok(NULL," \t\n");

      if (*(token+strlen(token)-1)==':')
        {
        fputs(token,fz80);
        if (token2!=NULL)
          {
          if (strlen(token)<8) putc('\t',fz80);
          fputc('\t',fz80);
          fputs(text+(token2-text_2)+n+1,fz80);
          }
        else fputc('\n',fz80);

        }
      else
        {
        fputs("\t\t",fz80);
        fputs(text+(token-text_2)+n+1,fz80);
        }
      }
    if (*text=='\n') fputc('\n',fz80);

    if ((i%100)==0) { gotoxy (2,wherey()); printf (" Line %d",i);}
    }
/* ----------------------------- */
  }










